#!/usr/bin/python
##### Smerni diagram potujocega vala na zici v polarnih koordinatah - S53MV 2.12.2017 #####

import math,numpy	#uporabljene funkcije

kh=3.0*math.pi	#dolzina zice v lambda*pi

k=0.01		#korak risanja v radianih

xk=[]		#polja za risanje kroga
yk=[]
xf=[]		#polja za risanje funkcije
yf=[]

t=-math.pi		#kot theta v radianih
fmax=0
while t<=math.pi:
	xk=xk+[math.sin(t)]	#referencni enotni krog
	yk=yk+[math.cos(t)]
	f=1.0			#izracun funkcije
	if math.fabs(math.sin(t))>k*0.1:
		f=math.sin(kh*(math.cos(t)-1))/(kh*(math.cos(t)-1))
	f=math.fabs(f*math.sin(t))
	if f>fmax:
		fmax=f
	xf=xf+[math.sin(t)*f]	#risanje funkcije
	yf=yf+[math.cos(t)*f]
	t=t+k			#povecaj t za korak

f=1.0/fmax			#normaliziraj risbo smernega diagrama
xf=numpy.multiply(xf,f)
yf=numpy.multiply(yf,f)

import matplotlib.pyplot as plt		#risanje grafa funkcije
plt.plot(xk,yk,'g-',lw=1)		#referencni enotni krog
plt.plot([-1,1],[0,0],'g-',lw=1.0)	#koordinatne osi
plt.plot([0,0],[-1,1],'g-',lw=1.0)
plt.plot(xf,yf,'b-',lw=2.0)		#risanje funkcije
plt.axis([-1.05,1.05,-1.05,1.05])
plt.xticks([])
plt.yticks([])
plt.title('Linearno radialno merilo')
plt.xlabel('Os z')
plt.ylabel('Ravnina xy')
plt.axes().set_aspect('equal')
plt.show()

#konec programa

